﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections;

namespace CustomOrderInGroup
{
    /// <summary>
    /// Interaction logic for Test.xaml
    /// </summary>
    public partial class Test : Window
    {
        public Test()
        {
            InitializeComponent();

            TextSummary Summary = new TextSummary();

            SummaryDefinition myTopSalesPersonFormula = new SummaryDefinition();
            myTopSalesPersonFormula.SourceFieldName = "IDName";
            myTopSalesPersonFormula.Calculator = Summary;
            this.xamDataGrid1.FieldLayouts[0].SummaryDefinitions.Add(myTopSalesPersonFormula);


            AbbreviationSortComparer grpCompare = new AbbreviationSortComparer();

            foreach (Field fld in xamDataGrid1.FieldLayouts[0].Fields)
            {
                fld.Settings.GroupByComparer = (IComparer)grpCompare;
            }

            List<DataCls> gdSource = new List<DataCls>();
            for (int cnt1 = 0; cnt1 <= 50; cnt1++)
            {
                for (int cnt2 = 1; cnt2 <= 2; cnt2++)
                {
                    gdSource.Add(new DataCls { ID = cnt1, Abbreviation = cnt1.ToString() + "Too Looooooooooong text to fit", IDName = "N" + cnt2.ToString() });
                }
            }

            //for (int cnt1 = 0; cnt1 <= 10; cnt1++)
            //{
            //    gdSource.Add(new DataCls { ID = 1.1234 * cnt1, Abbreviation = "z" + cnt1.ToString(), IDName = "N" + (2 * cnt1).ToString() });
            //}
            xamDataGrid1.DataSource = gdSource;
        }

        //private void ContentControl_Loaded(object sender, RoutedEventArgs e)
        //{
        //    if ((sender as ContentControl).Content.ToString().Contains("item"))
        //    {
        //        (sender as ContentControl).Content = string.Empty;
        //    }
        //}

        public string GetFitText(string strActualtext, double dblAvailablewidth)
        {
            if ((strActualtext.Length <= 0) || (dblAvailablewidth <= 0))
                return "";

            int intLen = strActualtext.Length;

            string strResult;

            while (true)
            {
                strResult = strActualtext.Substring(0, intLen);
                System.Windows.Media.FormattedText objFrmtText = new System.Windows.Media.FormattedText(strResult,
                                                       System.Globalization.CultureInfo.GetCultureInfo("en-us"),
                                                       FlowDirection.LeftToRight,
                                                       new System.Windows.Media.Typeface(xamDataGrid1.FontFamily.Source),
                                                       xamDataGrid1.FontSize,
                                                       System.Windows.Media.Brushes.Black);
                objFrmtText.SetFontWeight(FontWeights.Bold);

                if (objFrmtText.Width <= dblAvailablewidth)
                    break;
                else
                    intLen--;
            }
            if (strActualtext != strResult)
            {
                strResult += "...";
            }
            return strResult;
        }

        bool bWidthFound = false;
        double dblGrpColWidth = 0;



        //*****************
        //I moved the implementation in a separate function in order to use it easier on multiple places.
        //*****************
        void Truncate()
        {
            //Here is the added code
            bool groupexist = false;
            for (int intcnt = 0; intcnt <= xamDataGrid1.FieldLayouts[0].SortedFields.Count - 1; intcnt++)
            {
                if (xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].IsGroupBy)
                {
                    groupexist = true;
                }
            }

            if (!groupexist)
                return;

            foreach (Record item in xamDataGrid1.Records)
            {
                // Truncate the labels on GroupBy records
                TruncateGroupByLabels(item);
                // In case the GroupBy records have nested GroupBy records
                if (item.HasChildren)
                {
                    GetChildGroupByRecords(item);
                }
            }
        }

        // on group by column resize
        void OnColumnSizeChanged(object sender, SizeChangedEventArgs e)
        {
            bWidthFound = false;


            //Here is the changed code
            Truncate();
        }

        

        // Execute recursively to retrieve all GroupBy records and set the labels

        public void GetChildGroupByRecords(Record record)
        {

            foreach (Record rec in record.ViewableChildRecords)
            {

                if (rec.HasChildren)
                {

                    GetChildGroupByRecords(rec);

                }

                TruncateGroupByLabels(rec);

            }

        }



        public void TruncateGroupByLabels(Record item)
        {

            GroupByRecord dr = item as GroupByRecord;

            if (dr != null)
            {
                if (!(bWidthFound))
                {
                    bWidthFound = true;
                    dblGrpColWidth = dr.GroupByField.LabelWidthResolved;
                }
                if (Convert.ToString(dr.Value).Trim().Length > 0)
                    item.Description = GetFitText(Convert.ToString(dr.Value), dblGrpColWidth + 10);  // additional 10 for group by indent space
                else
                    item.Description = " ";
            }

        }

        private void Relpad_Click(object sender, RoutedEventArgs e)
        {
            List<DataCls> gdSource = new List<DataCls>();

            gdSource.Add(new DataCls { ID = 1, Abbreviation = "", IDName = "N1" });
            gdSource.Add(new DataCls { ID = 1, Abbreviation = "", IDName = "N2" });

            for (int cnt1 = 0; cnt1 <= 50; cnt1++)
            {
                for (int cnt2 = 1; cnt2 <= 2; cnt2++)
                {
                    gdSource.Add(new DataCls { ID = cnt1, Abbreviation = cnt1.ToString() + "New Too Looooooooooong text to fit", IDName = "N" + cnt2.ToString() });
                }
            }

            xamDataGrid1.DataSource = gdSource;



            //Here is the added code
            //bool groupexist = false;
            //for (int intcnt = 0; intcnt <= xamDataGrid1.FieldLayouts[0].SortedFields.Count - 1; intcnt++)
            //{
            //    if (xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].IsGroupBy)
            //    {
            //        groupexist = true;
            //    }
            //}

            //if (groupexist)
                Truncate();
        }
    }
    public class DataCls
    {
        public double ID { get; set; }
        public string Abbreviation { get; set; }
        public string IDName { get; set; }
    }
    public class SummaryTextFormatNumeric : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            SummaryResult sr = (value as SummaryResult);
            string strformat = "N1"; // Data.DataSource.dicColFrmts[sr.SourceField.Name];
            if (sr.Value != null)
            {
                double dbldata;
                if (double.TryParse(sr.Value.ToString(), out dbldata))
                    return Double.Parse(sr.Value.ToString()).ToString(strformat);
                else
                    return sr.Value;
            }
            return Double.Parse("0").ToString(strformat);
            return sr.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }

    public class SummaryTextAlign : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            SummaryResult sr = (value as SummaryResult);
            if (sr.Value != null)
            {
                double dbldata;
                if (double.TryParse(sr.Value.ToString(), out dbldata))
                    return "Right";
                else
                    return "Center";
            }
            return "Center";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }

    public class AbbreviationSortComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            var gbX = x as GroupByRecord;
            var gbY = y as GroupByRecord;

            if (gbX == gbY)
                return 0;
            else if (gbX == null)
                return -1;
            else if (gbY == null)
                return 1;

            /*** Begin Remove item text****/

            //if (gbX.Value.ToString() == "")
            //{
            //    gbX.Description = " ";
            //}
            //else
            //{
            //    gbX.Description = Convert.ToString(gbX.Value);
            //}

            //if (gbY.Value.ToString() == "")
            //{
            //    gbY.Description = " ";
            //}
            //else
            //{
            //    gbY.Description = Convert.ToString(gbY.Value);
            //}

            var summariesX = gbX.ChildRecords.SummaryResults;
            var summariesY = gbY.ChildRecords.SummaryResults;

            // sorting on summary column (in case group by selected and trying to sort on summary column)
            if (summariesX.Count != 0)
            {
                //ex: ID column summary
                var result = Comparer.Default.Compare(summariesX[0].Value, summariesY[0].Value);

                if (result != 0)
                    return result;

            }

            if (gbX.Value == DBNull.Value && gbY.Value == DBNull.Value)
                return 0;
            else if (gbX.Value == DBNull.Value)
                return -1;
            else if (gbY.Value == DBNull.Value)
                return 1;
            else
                return Comparer.Default.Compare(gbX.Value, gbY.Value);
        }
    }

    public class TextSummary : SummaryCalculator
    {
        private string summaryresult;
        public override void BeginCalculation(SummaryResult summaryResult)
        {
            summaryresult = string.Empty;
        }

        public override bool CanProcessDataType(Type dataType)
        {
            return Infragistics.Windows.Utilities.IsNumericType(dataType);
        }

        public override void Aggregate(object dataValue, SummaryResult summaryResult, Record record)
        {
            summaryresult = "--";
        }

        public override object EndCalculation(SummaryResult summaryResult)
        {
            return summaryresult;
        }

        public override string Name
        {
            get { return ""; }
        }

        public override string Description
        {
            get { return ""; }
        }


    }
}
